#pragma once
#include <string>
#include <Eigen/Dense>
#include <odeSD/DefaultSensitivityModel>

class XieModel :
	public odeSD::DefaultSensitivityModel
{
public:
	odeSD::SensitivityState initialState;

	virtual void observeIntermediateSensitivityState(Eigen::DenseIndex stepIndex, const odeSD::SensitivityState& state)
	{
		return;
	}

	virtual void observeIntermediateState(Eigen::DenseIndex stepIndex, const odeSD::State& state)
	{
		return;
	}

	XieModel() :
		initialState(24, 49)
	{
		initialState.x << 0.5566, 0.4982, 0.003185, 0.003185, 0.2583, 0.2395, 0.4014, 0.003185, 0.2571, 3.175, 0.003185, 0.3175, 4.1953, 3.6628, 2.7527, 0.003185, 0.2395, 2.7527, 0.0431, 0.0585, 0.08, 0.489, 0.426, 0.043;
		
		initialState.s.setZero();

		parameters = Eigen::VectorXd(initialState.nParameters);
		parameters << 1, 15.06, 0.069, 0.262, 51, 0.053, 36, 11, 0.028, 1.226, 1.42, 2.349, 0.2, 0.89, 1.1, 2.93, 0.62, 16.86, 9.831, 0.07, 0.06, 7.89, 14.68, 1.87, 0.1, 0.062, 0.276, 0.145, 125.54, 0.643, 1.858, 1.155, 1.043, 0.952, 0.053, 0.156, 35, 0.184, 0.279, 0.62, 0.053, 36, 0.069, 0.262, 11, 5, 4, 6, 1;

		tspan = Eigen::VectorXd(200);
		for (Eigen::DenseIndex i = 0; i < tspan.rows(); i++)
		{
			tspan(i) = i * 100.0 / (tspan.rows() - 1.0);
		}

		states = Eigen::MatrixXd(initialState.nStates, tspan.rows());
		sensitivities = Eigen::MatrixXd(initialState.nStates * initialState.nParameters, tspan.rows());
	}

	odeSD::SensitivityState& getInitialState()
	{
		return initialState;
	}



	// time, current state, f, f'
	virtual void calculateRHS(odeSD::State& state)
	{
		Eigen::VectorXd& p = parameters;
		Eigen::Map<Eigen::VectorXd>& f = state.f;
		Eigen::Map<Eigen::VectorXd>& dfdt = state.fPrime;
		Eigen::Map<Eigen::VectorXd>& x = state.x;
		

		/***********************************************
		* 1st DERIVATIVE EQUATIONS (f)
		**********************************************/

		f[0] = p[13] * x[0] * -1.0 + p[21] * x[1] - p[37] * x[0] * 1.0 + p[0] * p[11] * x[13] - p[4] * x[0] * x[6] * 1.0;
		f[1] = -p[1] * x[1] - p[21] * x[1] + p[4] * x[0] * x[6];
		f[2] = 0.0;
		f[3] = 0.0;
		f[4] = p[29] * x[4] * -1.0 + x[2] * (p[28] * x[22] + p[34] * x[21] - p[10] * (x[21] + x[22] - 1.0)*1.0);
		f[5] = p[5] * x[5] * -1.0 - (p[7] * (pow(x[18] * -1.0 + 1.0, p[45]) - 1.0) - pow(x[18] * -1.0 + 1.0, p[45])*p[8] * 1.0)*x[3] * 1.0;
		f[6] = -p[15] * x[6] + p[21] * x[1] - p[38] * x[6] - p[4] * x[0] * x[6] + p[14] * x[14] * x[17];
		f[7] = 0.0;
		f[8] = p[19] * x[8] * -1.0 - (p[17] * (pow(x[19] * -1.0 + 1.0, p[46]) - 1.0) - pow(x[19] * -1.0 + 1.0, p[46])*p[8] * 1.0)*x[7] * 1.0;
		f[9] = -p[9] * x[9] + p[22] * x[8];
		f[10] = 0.0;
		f[11] = p[20] * x[11] * -1.0 - (p[18] * (pow(x[20] * -1.0 + 1.0, p[47]) - 1.0) - pow(x[20] * -1.0 + 1.0, p[47])*p[8] * 1.0)*x[10] * 1.0;
		f[12] = p[23] * x[11] - p[35] * x[12] * 1.0;
		f[13] = p[13] * x[0] - p[12] * x[13] + p[36] * x[4] - p[0] * p[11] * x[13];
		f[14] = p[6] * x[5] + p[15] * x[6] - p[16] * x[14] * 1.0 - p[14] * x[14] * x[17] * 1.0;
		f[15] = 0.0;
		f[16] = p[40] * x[16] * -1.0 - (p[44] * (pow(x[23] * -1.0 + 1.0, p[45]) - 1.0) - pow(x[23] * -1.0 + 1.0, p[45])*p[8] * 1.0)*x[15] * 1.0;
		f[17] = p[15] * x[6] - p[39] * x[17] + p[41] * x[16] - p[14] * x[14] * x[17];
		f[18] = p[2] * x[0] - p[3] * x[18] - p[2] * x[0] * x[18];
		f[19] = p[24] * x[0] - p[26] * x[19] - p[24] * x[0] * x[19];
		f[20] = p[25] * x[0] - p[27] * x[20] - p[25] * x[0] * x[20];
		f[21] = p[32] * x[21] * -1.0 - p[30] * x[9] * (x[21] + x[22] - 1.0)*1.0;
		f[22] = p[33] * x[22] * -1.0 - p[31] * x[12] * (x[21] + x[22] - 1.0)*1.0;
		f[23] = p[42] * x[0] - p[43] * x[23] - p[42] * x[0] * x[23];

		/***********************************************
		* 2nd DERIVATIVE EQUATIONS (Jfx*f = g)
		**********************************************/


		dfdt[0] = -f[0] * (p[4] * x[6] * 1.0 + p[13] * 1.0 + p[37] * 1.0) + f[1] * p[21] + f[13] * p[0] * p[11] - f[6] * p[4] * x[0] * 1.0;
		dfdt[1] = -f[1] * (p[1] + p[21]) + f[0] * p[4] * x[6] + f[6] * p[4] * x[0];
		dfdt[2] = 0.0;
		dfdt[3] = 0.0;
		dfdt[4] = f[2] * (p[28] * x[22] + p[34] * x[21] - p[10] * (x[21] + x[22] - 1.0)*1.0) - f[4] * p[29] * 1.0 - f[22] * x[2] * (p[10] * 1.0 - p[28]) - f[21] * x[2] * (p[10] * 1.0 - p[34]);
		dfdt[5] = f[3] * (p[7] * pow(-x[18] + 1.0, p[45])*-1.0 + p[8] * pow(-x[18] + 1.0, p[45]) + p[7]) - f[5] * p[5] * 1.0 - ((p[7] - p[8] * 1.0)*f[18] * p[45] * x[3] * pow(-x[18] + 1.0, p[45])*1.0) / (x[18] - 1.0);
		dfdt[6] = -f[6] * (p[4] * x[0] + p[15] + p[38]) + f[1] * p[21] - f[0] * p[4] * x[6] + f[14] * p[14] * x[17] + f[17] * p[14] * x[14];
		dfdt[7] = 0.0;
		dfdt[8] = f[7] * (p[8] * pow(-x[19] + 1.0, p[46]) - p[17] * pow(-x[19] + 1.0, p[46])*1.0 + p[17]) - f[8] * p[19] * 1.0 + ((p[8] - p[17] * 1.0)*f[19] * p[46] * x[7] * pow(-x[19] + 1.0, p[46])*1.0) / (x[19] - 1.0);
		dfdt[9] = -f[9] * p[9] + f[8] * p[22];
		dfdt[10] = 0.0;
		dfdt[11] = f[10] * (p[8] * pow(-x[20] + 1.0, p[47]) - p[18] * pow(-x[20] + 1.0, p[47])*1.0 + p[18]) - f[11] * p[20] * 1.0 + ((p[8] - p[18] * 1.0)*f[20] * p[47] * x[10] * pow(-x[20] + 1.0, p[47])*1.0) / (x[20] - 1.0);
		dfdt[12] = f[11] * p[23] - f[12] * p[35] * 1.0;
		dfdt[13] = -(p[12] + p[0] * p[11])*f[13] + f[0] * p[13] + f[4] * p[36];
		dfdt[14] = -(p[14] * x[17] * 1.0 + p[16] * 1.0)*f[14] + f[5] * p[6] + f[6] * p[15] - f[17] * p[14] * x[14] * 1.0;
		dfdt[15] = 0.0;
		dfdt[16] = f[15] * (p[8] * pow(-x[23] + 1.0, p[45]) - p[44] * pow(-x[23] + 1.0, p[45])*1.0 + p[44]) - f[16] * p[40] * 1.0 + ((p[8] - p[44] * 1.0)*f[23] * p[45] * x[15] * pow(-x[23] + 1.0, p[45])*1.0) / (x[23] - 1.0);
		dfdt[17] = -(p[14] * x[14] + p[39])*f[17] + f[6] * p[15] + f[16] * p[41] - f[14] * p[14] * x[17];
		dfdt[18] = -(p[2] * x[0] + p[3])*f[18] - (p[2] * x[18] - p[2])*f[0];
		dfdt[19] = -(p[24] * x[0] + p[26])*f[19] - (p[24] * x[19] - p[24])*f[0];
		dfdt[20] = -(p[25] * x[0] + p[27])*f[20] - (p[25] * x[20] - p[25])*f[0];
		dfdt[21] = -(p[30] * x[9] * 1.0 + p[32] * 1.0)*f[21] - f[9] * p[30] * (x[21] + x[22] - 1.0)*1.0 - f[22] * p[30] * x[9] * 1.0;
		dfdt[22] = -(p[31] * x[12] * 1.0 + p[33] * 1.0)*f[22] - f[12] * p[31] * (x[21] + x[22] - 1.0)*1.0 - f[21] * p[31] * x[12] * 1.0;
		dfdt[23] = -(p[42] * x[0] + p[43])*f[23] - (p[42] * x[23] - p[42])*f[0];
		

	}

	virtual void calculateJac(odeSD::JacobianState& jacState, odeSD::State& state)
	{
		Eigen::VectorXd& p = parameters;
		Eigen::Map<Eigen::VectorXd>& f = state.f;
		Eigen::Map<Eigen::VectorXd>& x = state.x;
		///***********************************************
		//* STATE JACOBIAN EQUATIONS (J)
		//**********************************************/

		jacState.dfdx.setZero();
		Eigen::Map<Eigen::VectorXd>& J = jacState.dfdxVector;

		J[0] = p[4] * x[6] * -1.0 - p[13] * 1.0 - p[37] * 1.0;
		J[1] = p[4] * x[6];
		J[6] = -p[4] * x[6];
		J[13] = p[13];
		J[18] = -p[2] * x[18] + p[2];
		J[19] = -p[24] * x[19] + p[24];
		J[20] = -p[25] * x[20] + p[25];
		J[23] = -p[42] * x[23] + p[42];
		J[24] = p[21];
		J[25] = -p[1] - p[21];
		J[30] = p[21];
		J[52] = p[28] * x[22] + p[34] * x[21] - p[10] * (x[21] + x[22] - 1.0)*1.0;
		J[77] = p[7] * (pow(x[18] * -1.0 + 1.0, p[45]) - 1.0)*-1.0 + pow(x[18] * -1.0 + 1.0, p[45])*p[8] * 1.0;
		J[100] = p[29] * -1.0;
		J[109] = p[36];
		J[125] = p[5] * -1.0;
		J[134] = p[6];
		J[144] = p[4] * x[0] * -1.0;
		J[145] = p[4] * x[0];
		J[150] = -p[4] * x[0] - p[15] - p[38];
		J[158] = p[15];
		J[161] = p[15];
		J[176] = p[17] * (pow(x[19] * -1.0 + 1.0, p[46]) - 1.0)*-1.0 + pow(x[19] * -1.0 + 1.0, p[46])*p[8] * 1.0;
		J[200] = p[19] * -1.0;
		J[201] = p[22];
		J[225] = -p[9];
		J[237] = p[30] * (x[21] + x[22] - 1.0)*-1.0;
		J[251] = p[18] * (pow(x[20] * -1.0 + 1.0, p[47]) - 1.0)*-1.0 + pow(x[20] * -1.0 + 1.0, p[47])*p[8] * 1.0;
		J[275] = p[20] * -1.0;
		J[276] = p[23];
		J[300] = p[35] * -1.0;
		J[310] = p[31] * (x[21] + x[22] - 1.0)*-1.0;
		J[312] = p[0] * p[11];
		J[325] = -p[12] - p[0] * p[11];
		J[342] = p[14] * x[17];
		J[350] = p[14] * x[17] * -1.0 - p[16] * 1.0;
		J[353] = -p[14] * x[17];
		J[376] = p[44] * (pow(x[23] * -1.0 + 1.0, p[45]) - 1.0)*-1.0 + pow(x[23] * -1.0 + 1.0, p[45])*p[8] * 1.0;
		J[400] = p[40] * -1.0;
		J[401] = p[41];
		J[414] = p[14] * x[14];
		J[422] = p[14] * x[14] * -1.0;
		J[425] = -p[14] * x[14] - p[39];
		J[437] = (pow(x[18] * -1.0 + 1.0, p[45] - 1.0)*p[7] * p[45] * 1.0 - pow(x[18] * -1.0 + 1.0, p[45] - 1.0)*p[8] * p[45] * 1.0)*x[3] * 1.0;
		J[450] = -p[2] * x[0] - p[3];
		J[464] = (pow(x[19] * -1.0 + 1.0, p[46] - 1.0)*p[8] * p[46] * 1.0 - pow(x[19] * -1.0 + 1.0, p[46] - 1.0)*p[17] * p[46] * 1.0)*x[7] * -1.0;
		J[475] = -p[24] * x[0] - p[26];
		J[491] = (pow(x[20] * -1.0 + 1.0, p[47] - 1.0)*p[8] * p[47] * 1.0 - pow(x[20] * -1.0 + 1.0, p[47] - 1.0)*p[18] * p[47] * 1.0)*x[10] * -1.0;
		J[500] = -p[25] * x[0] - p[27];
		J[508] = -x[2] * (p[10] * 1.0 - p[34]);
		J[525] = p[30] * x[9] * -1.0 - p[32] * 1.0;
		J[526] = p[31] * x[12] * -1.0;
		J[532] = -x[2] * (p[10] * 1.0 - p[28]);
		J[549] = p[30] * x[9] * -1.0;
		J[550] = p[31] * x[12] * -1.0 - p[33] * 1.0;
		J[568] = (pow(x[23] * -1.0 + 1.0, p[45] - 1.0)*p[8] * p[45] * 1.0 - pow(x[23] * -1.0 + 1.0, p[45] - 1.0)*p[44] * p[45] * 1.0)*x[15] * -1.0;
		J[575] = -p[42] * x[0] - p[43];

		jacState.dfPrimedx.setZero();
		Eigen::Map<Eigen::VectorXd> dJ = jacState.dfPrimedxVector;


		dJ[0] = f[6] * p[4] * -1.0;
		dJ[1] = f[6] * p[4];
		dJ[6] = -f[6] * p[4];
		dJ[18] = -f[18] * p[2];
		dJ[19] = -f[19] * p[24];
		dJ[20] = -f[20] * p[25];
		dJ[23] = -f[23] * p[42];
		dJ[52] = -f[22] * (p[10] * 1.0 - p[28]) - f[21] * (p[10] * 1.0 - p[34]);
		dJ[77] = (p[7] - p[8] * 1.0)*f[18] * p[45] * pow(-x[18] + 1.0, p[45] - 1.0)*1.0;
		dJ[144] = f[0] * p[4] * -1.0;
		dJ[145] = f[0] * p[4];
		dJ[150] = -f[0] * p[4];
		dJ[176] = (p[8] - p[17] * 1.0)*f[19] * p[46] * pow(-x[19] + 1.0, p[46] - 1.0)*-1.0;
		dJ[237] = -p[30] * (f[21] + f[22]);
		dJ[251] = (p[8] - p[18] * 1.0)*f[20] * p[47] * pow(-x[20] + 1.0, p[47] - 1.0)*-1.0;
		dJ[310] = -p[31] * (f[21] + f[22]);
		dJ[342] = f[17] * p[14];
		dJ[350] = f[17] * p[14] * -1.0;
		dJ[353] = -f[17] * p[14];
		dJ[376] = (p[8] - p[44] * 1.0)*f[23] * p[45] * pow(-x[23] + 1.0, p[45] - 1.0)*-1.0;
		dJ[414] = f[14] * p[14];
		dJ[422] = f[14] * p[14] * -1.0;
		dJ[425] = -f[14] * p[14];
		dJ[437] = (p[7] - p[8] * 1.0)*p[45] * pow(-x[18] + 1.0, p[45] - 2.0)*(f[3] - f[3] * x[18] + f[18] * x[3] - f[18] * p[45] * x[3])*1.0;
		dJ[450] = -f[0] * p[2];
		dJ[464] = (p[8] - p[17] * 1.0)*p[46] * pow(-x[19] + 1.0, p[46] - 2.0)*(f[7] - f[7] * x[19] + f[19] * x[7] - f[19] * p[46] * x[7])*-1.0;
		dJ[475] = -f[0] * p[24];
		dJ[491] = (p[8] - p[18] * 1.0)*p[47] * pow(-x[20] + 1.0, p[47] - 2.0)*(f[10] - f[10] * x[20] + f[20] * x[10] - f[20] * p[47] * x[10])*-1.0;
		dJ[500] = -f[0] * p[25];
		dJ[508] = -(p[10] - p[34] * 1.0)*f[2];
		dJ[525] = f[9] * p[30] * -1.0;
		dJ[526] = f[12] * p[31] * -1.0;
		dJ[532] = -(p[10] - p[28] * 1.0)*f[2];
		dJ[549] = f[9] * p[30] * -1.0;
		dJ[550] = f[12] * p[31] * -1.0;
		dJ[568] = (p[8] - p[44] * 1.0)*p[45] * pow(-x[23] + 1.0, p[45] - 2.0)*(f[15] - f[15] * x[23] + f[23] * x[15] - f[23] * p[45] * x[15])*-1.0;
		dJ[575] = -f[0] * p[42];

		jacState.dfPrimedx += jacState.dfdx * jacState.dfdx;
	}

	virtual void calculateJacAndSensitivities(odeSD::JacobianState& jacState, odeSD::SensitivityState& state)
	{
		calculateJac(jacState, state);
		Eigen::VectorXd& p = parameters;
		Eigen::Map<Eigen::VectorXd>& f = state.f;
		Eigen::Map<Eigen::VectorXd>& x = state.x;

		// Sensitivities

		state.dfdp.setZero();
		Eigen::Map<Eigen::VectorXd>& dfdp = state.dfdpVector;

		dfdp[0] = p[11] * x[13];
		dfdp[13] = -p[11] * x[13];
		dfdp[25] = -x[1];
		dfdp[66] = -x[0] * x[18] + x[0];
		dfdp[90] = -x[18];
		dfdp[96] = x[0] * x[6] * -1.0;
		dfdp[97] = x[0] * x[6];
		dfdp[102] = -x[0] * x[6];
		dfdp[125] = x[5] * -1.0;
		dfdp[158] = x[5];
		dfdp[173] = x[3] * (pow(x[18] * -1.0 + 1.0, p[45]) - 1.0)*-1.0;
		dfdp[197] = pow(x[18] * -1.0 + 1.0, p[45])*x[3] * 1.0;
		dfdp[200] = pow(x[19] * -1.0 + 1.0, p[46])*x[7] * 1.0;
		dfdp[203] = pow(x[20] * -1.0 + 1.0, p[47])*x[10] * 1.0;
		dfdp[208] = pow(x[23] * -1.0 + 1.0, p[45])*x[15] * 1.0;
		dfdp[225] = -x[9];
		dfdp[244] = -x[2] * (x[21] * 1.0 + x[22] * 1.0 - 1.0);
		dfdp[264] = p[0] * x[13];
		dfdp[277] = -p[0] * x[13];
		dfdp[301] = -x[13];
		dfdp[312] = x[0] * -1.0;
		dfdp[325] = x[0];
		dfdp[342] = x[14] * x[17];
		dfdp[350] = x[14] * x[17] * -1.0;
		dfdp[353] = -x[14] * x[17];
		dfdp[366] = -x[6];
		dfdp[374] = x[6];
		dfdp[377] = x[6];
		dfdp[398] = x[14] * -1.0;
		dfdp[416] = x[7] * (pow(x[19] * -1.0 + 1.0, p[46]) - 1.0)*-1.0;
		dfdp[443] = x[10] * (pow(x[20] * -1.0 + 1.0, p[47]) - 1.0)*-1.0;
		dfdp[464] = x[8] * -1.0;
		dfdp[491] = x[11] * -1.0;
		dfdp[504] = x[1];
		dfdp[505] = -x[1];
		dfdp[510] = x[1];
		dfdp[537] = x[8];
		dfdp[564] = x[11];
		dfdp[595] = -x[0] * x[19] + x[0];
		dfdp[620] = -x[0] * x[20] + x[0];
		dfdp[643] = -x[19];
		dfdp[668] = -x[20];
		dfdp[676] = x[2] * x[22];
		dfdp[700] = x[4] * -1.0;
		dfdp[741] = x[9] * (x[21] + x[22] - 1.0)*-1.0;
		dfdp[766] = x[12] * (x[21] + x[22] - 1.0)*-1.0;
		dfdp[789] = x[21] * -1.0;
		dfdp[814] = x[22] * -1.0;
		dfdp[820] = x[2] * x[21];
		dfdp[852] = x[12] * -1.0;
		dfdp[877] = x[4];
		dfdp[888] = x[0] * -1.0;
		dfdp[918] = -x[6];
		dfdp[953] = -x[17];
		dfdp[976] = x[16] * -1.0;
		dfdp[1001] = x[16];
		dfdp[1031] = -x[0] * x[23] + x[0];
		dfdp[1055] = -x[23];
		dfdp[1072] = x[15] * (pow(x[23] * -1.0 + 1.0, p[45]) - 1.0)*-1.0;
		dfdp[1085] = (log(x[18] * -1.0 + 1.0)*pow(x[18] * -1.0 + 1.0, p[45])*p[7] - log(x[18] * -1.0 + 1.0)*pow(x[18] * -1.0 + 1.0, p[45])*p[8] * 1.0)*x[3] * -1.0;
		dfdp[1096] = (log(x[23] * -1.0 + 1.0)*pow(x[23] * -1.0 + 1.0, p[45])*p[8] * 1.0 - log(x[23] * -1.0 + 1.0)*pow(x[23] * -1.0 + 1.0, p[45])*p[44])*x[15] * 1.0;
		dfdp[1112] = (log(x[19] * -1.0 + 1.0)*pow(x[19] * -1.0 + 1.0, p[46])*p[8] * 1.0 - log(x[19] * -1.0 + 1.0)*pow(x[19] * -1.0 + 1.0, p[46])*p[17])*x[7] * 1.0;
		dfdp[1139] = (log(x[20] * -1.0 + 1.0)*pow(x[20] * -1.0 + 1.0, p[47])*p[8] * 1.0 - log(x[20] * -1.0 + 1.0)*pow(x[20] * -1.0 + 1.0, p[47])*p[18])*x[10] * 1.0;

		state.dfPrimedp.setZero();
		Eigen::Map<Eigen::VectorXd>& d2fdtdp = state.dfPrimedpVector;

		d2fdtdp[0] = f[13] * p[11];
		d2fdtdp[13] = -f[13] * p[11];
		d2fdtdp[25] = -f[1];
		d2fdtdp[66] = -(x[18] - 1.0)*f[0] - f[18] * x[0];
		d2fdtdp[90] = -f[18];
		d2fdtdp[96] = -f[0] * x[6] - f[6] * x[0];
		d2fdtdp[97] = f[0] * x[6] + f[6] * x[0];
		d2fdtdp[102] = -f[0] * x[6] - f[6] * x[0];
		d2fdtdp[125] = f[5] * -1.0;
		d2fdtdp[158] = f[5];
		d2fdtdp[173] = f[3] - pow(x[18] * -1.0 + 1.0, p[45])*f[3] * 1.0 - (pow(x[18] * -1.0 + 1.0, p[45])*f[18] * p[45] * x[3] * 1.0) / (x[18] - 1.0);
		d2fdtdp[197] = -pow(-x[18] + 1.0, p[45] - 1.0)*(f[3] * -1.0 + f[3] * x[18] * 1.0 + f[18] * p[45] * x[3] * 1.0);
		d2fdtdp[200] = -pow(-x[19] + 1.0, p[46] - 1.0)*(f[7] * -1.0 + f[7] * x[19] * 1.0 + f[19] * p[46] * x[7] * 1.0);
		d2fdtdp[203] = -pow(-x[20] + 1.0, p[47] - 1.0)*(f[10] * -1.0 + f[10] * x[20] * 1.0 + f[20] * p[47] * x[10] * 1.0);
		d2fdtdp[208] = -pow(-x[23] + 1.0, p[45] - 1.0)*(f[15] * -1.0 + f[15] * x[23] * 1.0 + f[23] * p[45] * x[15] * 1.0);
		d2fdtdp[225] = -f[9];
		d2fdtdp[244] = -f[2] * (x[21] * 1.0 + x[22] * 1.0 - 1.0) - f[21] * x[2] * 1.0 - f[22] * x[2] * 1.0;
		d2fdtdp[264] = f[13] * p[0];
		d2fdtdp[277] = -f[13] * p[0];
		d2fdtdp[301] = -f[13];
		d2fdtdp[312] = f[0] * -1.0;
		d2fdtdp[325] = f[0];
		d2fdtdp[342] = f[14] * x[17] + f[17] * x[14];
		d2fdtdp[350] = -f[14] * x[17] - f[17] * x[14];
		d2fdtdp[353] = -f[14] * x[17] - f[17] * x[14];
		d2fdtdp[366] = -f[6];
		d2fdtdp[374] = f[6];
		d2fdtdp[377] = f[6];
		d2fdtdp[398] = f[14] * -1.0;
		d2fdtdp[416] = f[7] - pow(x[19] * -1.0 + 1.0, p[46])*f[7] * 1.0 - (pow(x[19] * -1.0 + 1.0, p[46])*f[19] * p[46] * x[7] * 1.0) / (x[19] - 1.0);
		d2fdtdp[443] = f[10] - pow(x[20] * -1.0 + 1.0, p[47])*f[10] * 1.0 - (pow(x[20] * -1.0 + 1.0, p[47])*f[20] * p[47] * x[10] * 1.0) / (x[20] - 1.0);
		d2fdtdp[464] = f[8] * -1.0;
		d2fdtdp[491] = f[11] * -1.0;
		d2fdtdp[504] = f[1];
		d2fdtdp[505] = -f[1];
		d2fdtdp[510] = f[1];
		d2fdtdp[537] = f[8];
		d2fdtdp[564] = f[11];
		d2fdtdp[595] = -(x[19] - 1.0)*f[0] - f[19] * x[0];
		d2fdtdp[620] = -(x[20] - 1.0)*f[0] - f[20] * x[0];
		d2fdtdp[643] = -f[19];
		d2fdtdp[668] = -f[20];
		d2fdtdp[676] = f[2] * x[22] + f[22] * x[2];
		d2fdtdp[700] = f[4] * -1.0;
		d2fdtdp[741] = -f[9] * (x[21] * 1.0 + x[22] * 1.0 - 1.0) - f[21] * x[9] * 1.0 - f[22] * x[9] * 1.0;
		d2fdtdp[766] = -f[12] * (x[21] * 1.0 + x[22] * 1.0 - 1.0) - f[21] * x[12] * 1.0 - f[22] * x[12] * 1.0;
		d2fdtdp[789] = f[21] * -1.0;
		d2fdtdp[814] = f[22] * -1.0;
		d2fdtdp[820] = f[2] * x[21] + f[21] * x[2];
		d2fdtdp[852] = f[12] * -1.0;
		d2fdtdp[877] = f[4];
		d2fdtdp[888] = f[0] * -1.0;
		d2fdtdp[918] = -f[6];
		d2fdtdp[953] = -f[17];
		d2fdtdp[976] = f[16] * -1.0;
		d2fdtdp[1001] = f[16];
		d2fdtdp[1031] = -(x[23] - 1.0)*f[0] - f[23] * x[0];
		d2fdtdp[1055] = -f[23];
		d2fdtdp[1072] = f[15] - pow(x[23] * -1.0 + 1.0, p[45])*f[15] * 1.0 - (pow(x[23] * -1.0 + 1.0, p[45])*f[23] * p[45] * x[15] * 1.0) / (x[23] - 1.0);
		d2fdtdp[1085] = -((p[7] - p[8] * 1.0)*pow(x[18] * -1.0 + 1.0, p[45])*(log(x[18] * -1.0 + 1.0)*f[3] * -1.0 + f[18] * x[3] + log(x[18] * -1.0 + 1.0)*f[3] * x[18] + log(x[18] * -1.0 + 1.0)*f[18] * p[45] * x[3])) / (x[18] - 1.0);
		d2fdtdp[1096] = ((p[8] - p[44] * 1.0)*pow(x[23] * -1.0 + 1.0, p[45])*(log(x[23] * -1.0 + 1.0)*f[15] * -1.0 + f[23] * x[15] + log(x[23] * -1.0 + 1.0)*f[15] * x[23] + log(x[23] * -1.0 + 1.0)*f[23] * p[45] * x[15])) / (x[23] - 1.0);
		d2fdtdp[1112] = ((p[8] - p[17] * 1.0)*pow(x[19] * -1.0 + 1.0, p[46])*(log(x[19] * -1.0 + 1.0)*f[7] * -1.0 + f[19] * x[7] + log(x[19] * -1.0 + 1.0)*f[7] * x[19] + log(x[19] * -1.0 + 1.0)*f[19] * p[46] * x[7])) / (x[19] - 1.0);
		d2fdtdp[1139] = ((p[8] - p[18] * 1.0)*pow(x[20] * -1.0 + 1.0, p[47])*(log(x[20] * -1.0 + 1.0)*f[10] * -1.0 + f[20] * x[10] + log(x[20] * -1.0 + 1.0)*f[10] * x[20] + log(x[20] * -1.0 + 1.0)*f[20] * p[47] * x[10])) / (x[20] - 1.0);

		state.dfPrimedp += jacState.dfdx * state.dfdp;

	}


};